#include <stdio.h>
#include <curl/curl.h>
#include <openssl/bio.h>

size_t wf(char *ptr, size_t size, size_t nmemb, void *userdata)
{
   return BIO_write((BIO *)userdata, ptr, size * nmemb);
}

int main(void)
{
  CURL *curl;
  CURLcode res;
  struct curl_slist *chunk = NULL;
  BIO *bio_mem = NULL;
  char *ptr = NULL;
  int len;

  bio_mem = BIO_new(BIO_s_mem());

  curl_global_init(CURL_GLOBAL_NOTHING);

  curl = curl_easy_init();
  if(curl) {
    chunk = curl_slist_append(chunk, "Content-Type: application/octet-stream");

    curl_easy_setopt(curl, CURLOPT_VERBOSE, 1L);
    curl_easy_setopt(curl, CURLOPT_URL, "http://www.hackingteam.com");
    curl_easy_setopt(curl, CURLOPT_HTTPHEADER, chunk);
    curl_easy_setopt(curl, CURLOPT_POSTFIELDS, "name=daniel&project=curl");
    curl_easy_setopt(curl, CURLOPT_POSTFIELDSIZE, 10);
    curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, wf);
    curl_easy_setopt(curl, CURLOPT_WRITEDATA, bio_mem);

    res = curl_easy_perform(curl);
    if(res != CURLE_OK)
      fprintf(stderr, "curl_easy_perform() failed: %s\n",
              curl_easy_strerror(res));

    curl_slist_free_all(chunk);
    curl_easy_cleanup(curl);
  }
  curl_global_cleanup();

  len = BIO_get_mem_data(bio_mem, &ptr);

  printf("%d\n", len);

  BIO_free(bio_mem);

  return 0;
}
